petsc-3.12.1 2019-10-22
Report Typos and Errors

# PCGASM

Use the (restricted) additive Schwarz method, each block is (approximately) solved with its own KSP object.

### Options Database Keys

| -pc_gasm_total_subdomains <n> | - Sets total number of local subdomains to be distributed among processors
| -pc_gasm_view_subdomains | - activates the printing of subdomain indices in PCView(), -ksp_view or -snes_view
| -pc_gasm_print_subdomains | - activates the printing of subdomain indices in PCSetUp()
| -pc_gasm_overlap <ovl> | - Sets overlap by which to (automatically) extend local subdomains
| -pc_gasm_type [basic,restrict,interpolate,none] | - Sets GASM type

IMPORTANT: If you run with, for example, 3 blocks on 1 processor or 3 blocks on 3 processors you will get a different convergence rate due to the default option of -pc_gasm_type restrict. Use -pc_gasm_type basic to use the standard GASM.

### Notes

Blocks can be shared by multiple processes.

To set options on the solvers for each block append -sub_ to all the KSP, and PC options database keys. For example, -sub_pc_type ilu -sub_pc_factor_levels 1 -sub_ksp_type preonly

To set the options on the solvers separate for each block call PCGASMGetSubKSP() and set the options directly on the resulting KSP object (you can access its PC with KSPGetPC())

### References

| 1. | - M Dryja, OB Widlund, An additive variant of the Schwarz alternating method for the case of many subregions Courant Institute, New York University Technical report
| 2. | - Barry Smith, Petter Bjorstad, and William Gropp, Domain Decompositions: Parallel Multilevel Methods for Elliptic Partial Differential Equations, Cambridge University Press.

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC,
PCBJACOBI, PCGASMGetSubKSP(), PCGASMSetSubdomains(), PCSetModifySubmatrices(), PCGASMSetOverlap(), PCGASMSetType()

### Level

beginner

### Location

src/ksp/pc/impls/gasm/gasm.c

### Examples

src/ksp/ksp/examples/tutorials/ex62.c.html
src/ksp/ksp/examples/tutorials/ex64.c.html
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages